package com.dsic.gj_erp.controller.txzz.jhgl;


import cn.hutool.core.util.StrUtil;
import com.alibaba.excel.EasyExcel;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.dsic.gj_erp.bean.txzz.DmMateria;
import com.dsic.gj_erp.annotation.Authorization;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.sy.SyDictItem;
import com.dsic.gj_erp.exception.CustomException;
import com.dsic.gj_erp.service.sy.SyDictItemService;
import com.dsic.gj_erp.service.txzz.DmMateriaService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import java.io.IOException;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 物品基本表 前端控制器
 * </p>
 *
 * @author xhj
 * @since 2021-03-29
 */

@RestController
@RequestMapping(value = "/api/gj/dmMateria")
@Api(tags = "物品基本表controller")
public class DmMateriaController {

    @Autowired
    DmMateriaService dmMateriaService;
    @Autowired
    SyDictItemService syDictItemService;

    /**
     * 根据铁舾物品号查询物品选择下拉框数据
     */
    @GetMapping("getMatGroup")
    public ResultBean getMatGroup(String txMatNo){
        List<DmMateria> list=dmMateriaService.list(Wrappers.<DmMateria>lambdaQuery()
                .select(DmMateria::getTxMatNo,DmMateria::getYlMatNo)
                .isNotNull(DmMateria::getTxMatNo)
                .isNotNull(DmMateria::getYlMatNo)
                .like(StrUtil.isNotEmpty(txMatNo),DmMateria::getTxMatNo,txMatNo)
                .groupBy(DmMateria::getYlMatNo));
        return new ResultBean(list);
    }

    @PostMapping("/getOpen")
    @ApiOperation("管系涂装工艺查询物资")
    public ResultBean  getOpen(@RequestBody Map<String, Object> paramMap){
        QueryWrapper qw = new QueryWrapper<DmMateria>();

        Map map = (Map)paramMap.get("dmMateria");

//        qw.eq("institution_code","02");
        qw.ne("mat_level","T");
        //仓库
        if (!StringUtils.isBlank((String)map.get("institutionCode"))){
                qw.eq("institution_code",map.get("institutionCode"));

        }
        //使用方式
        if (!StringUtils.isBlank((String)map.get("userCateg"))){
            qw.ne("use_categ",map.get("userCateg"));

        }
        //物品号
        if (!StringUtils.isBlank((String)map.get("matNo"))){
            qw.like("mat_no",map.get("matNo"));
        }
        //物品名称
        if (!StringUtils.isBlank((String)map.get("matName"))){
            qw.like("mat_name",map.get("matName"));
        }
        //物品规格
        if (!StringUtils.isBlank((String)map.get("matSpec"))){
            qw.like("mat_spec",map.get("matSpec"));
        }
        //物品材质
        if (!StringUtils.isBlank((String)map.get("matGrd"))){
            qw.like("mat_grd",map.get("matGrd"));
        }
        //图号
        if (!StringUtils.isBlank((String)map.get("matVersion"))){
            qw.like("mat_version",map.get("matVersion"));
        }



        List list = dmMateriaService.list(qw);
        return new ResultBean(list);
    }

//    @PostMapping(value = "/del")
//    public ResultBean del(@RequestBody List<String> delArr) {
//        dmMateriaService.removeByIds(delArr);
//        return  new  ResultBean();
//    }
//
//    @PostMapping(value = "/update")
//    public ResultBean update(@RequestBody List<DmMateria> dmMateria) {
//        dmMateriaService.updateBatchById(dmMateria);
//        return  new  ResultBean();
//    }

    @PostMapping(value = "/openBase")
    public ResultBean  openBase(@RequestBody Map<String, Object> paramMap){
        return new ResultBean<>( dmMateriaService.getBase(paramMap));
    }

    /**
     * @author 张恩铭
     * @param dmMateria
     * @return
     */
    @ApiOperation("物品全部条件查询")
    @PostMapping("/getallcon")
    public ResultBean<List<DmMateria>> getAllCon(@RequestBody DmMateria dmMateria){
        return this.dmMateriaService.getAllCon(dmMateria);
    }

    /**
     * @author 张恩铭
     * @param dmMateria
     * @return
     */
    @ApiOperation("物品管系条件查询")
    @PostMapping("/getcon")
    public ResultBean<List<DmMateria>> getCon(@RequestBody DmMateria dmMateria){
        return this.dmMateriaService.getCon(dmMateria);
    }

    /**
     * @author 张恩铭
     * @param dmMaterias
     * @return
     */
    @ApiOperation("物品添加")
    @PostMapping("/add")
    @Authorization
    public ResultBean<Integer> addMateria(@RequestBody DmMateria[] dmMaterias,HttpServletRequest req){
        return this.dmMateriaService.addMateria(dmMaterias,req);
    }

    /**
     * @author 张恩铭
     * @param dmMaterias
     * @return
     */
    @ApiOperation("物品修改")
    @PostMapping("/update")
    public ResultBean<Integer> updateMateria(@RequestBody DmMateria[] dmMaterias,HttpServletRequest req){
        return this.dmMateriaService.updateMateria(dmMaterias,req);
    }

    /**
     * @author 张恩铭
     * @param dmMaterias
     * @return
     */
    @ApiOperation("物品删除")
    @PostMapping("/del")
    public ResultBean<Integer> delMateria(@RequestBody DmMateria[] dmMaterias){
        return this.dmMateriaService.delMateria(dmMaterias);
    }


    @PostMapping(value = "/base")
    public ResultBean  getbase(@RequestBody Map<String, Object> paramMap){
        return new ResultBean<>( dmMateriaService.getjcsjWpBase(paramMap));
    }

    @PostMapping(value = "/baseForTX")
    public ResultBean  getbaseForTX(@RequestBody Map<String, Object> paramMap){
        List<SyDictItem> gzlx = syDictItemService.list(new QueryWrapper<SyDictItem>().eq("dict_code", "GZLX"));
        List<SyDictItem> wplx = syDictItemService.list(new QueryWrapper<SyDictItem>().eq("dict_code", "WPLX"));
        Map dictMap =dmMateriaService.getjcsjWpBase(paramMap);
        dictMap.put("gzlx",gzlx);
        dictMap.remove("wplx");
        dictMap.put("wplx",wplx);
        return new ResultBean<>(dictMap);
    }

    @ApiOperation("添加（军品）")
    @PostMapping("/save")
    public ResultBean<Integer> saveMateria(@RequestBody List<DmMateria> dmMaterias){
        this.dmMateriaService.saveOrUpdateBatch(dmMaterias);
        return new ResultBean<>();
    }

}

