package com.dsic.gj_erp.service.pgd.impl;

import cn.hutool.core.date.DateUtil;
import com.dsic.gj_erp.bean.pgd.PgdPwjh;
import com.dsic.gj_erp.bean.pgd.PgdSljh;
import com.dsic.gj_erp.mapper.pgd.PgdPwjhMapper;
import com.dsic.gj_erp.service.pgd.PgdPwjhService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-11-13
 */
@Service
public class PgdPwjhServiceImpl extends ServiceImpl<PgdPwjhMapper, PgdPwjh> implements PgdPwjhService {

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void savePwjhPg(List<PgdPwjh> sljhs, HttpServletRequest request) {

        List<PgdPwjh>ups= new ArrayList<>();
        sljhs.forEach(f->{
            PgdPwjh e= new PgdPwjh();
            e.setXfry((String) request.getAttribute("yhms"));
            e.setXfrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm:ss"));
            e.setZt("02");
            e.setScdw(f.getScdw());
            e.setScry(f.getScry());
            e.setId(f.getId());
            ups.add(e);
        });
        this.updateBatchById(ups);
    }


    @Transactional(rollbackFor = Exception.class)
    @Override
    public void savePwjhPgBack(List<PgdPwjh> sljhs, HttpServletRequest request) {

        List<PgdPwjh>ups= new ArrayList<>();
        sljhs.forEach(f->{
            PgdPwjh e= new PgdPwjh();
            e.setXfry("");
            e.setXfrq("");
            e.setZt("01");
            e.setScdw("");
            e.setScry("");
            e.setId(f.getId());
            ups.add(e);
        });
        this.updateBatchById(ups);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void savePwPgdXd(List<PgdPwjh> pwjhs, HttpServletRequest request) {
        List<PgdPwjh>ups= new ArrayList<>();
        pwjhs.forEach(f->{
            PgdPwjh e= new PgdPwjh();
            e.setJsry((String) request.getAttribute("yhms"));
            e.setJsrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm:ss"));
            e.setZt("03");
            e.setId(f.getId());
            ups.add(e);
        });
        this.updateBatchById(ups);
    }




    @Override
    @Transactional(rollbackFor = Exception.class)
    public void savePwPgdFk(List<PgdPwjh> pwjhs, HttpServletRequest request) {
        List<PgdPwjh>ups= new ArrayList<>();
        pwjhs.forEach(f->{
            PgdPwjh e= new PgdPwjh();
            e.setFkry((String) request.getAttribute("yhms"));
            e.setFkrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm:ss"));
            e.setZt("04");
            e.setFkyy(f.getFkyy());
            e.setId(f.getId());
            ups.add(e);
        });
        this.updateBatchById(ups);
    }

    @Override
    public void savePwFk(List<PgdPwjh> pwjhs, HttpServletRequest request) {

        List<PgdPwjh>ups= new ArrayList<>();
        pwjhs.forEach(f->{
            PgdPwjh e= new PgdPwjh();
            e.setFkry((String) request.getAttribute("yhms"));
            e.setFkrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm:ss"));
            e.setZt("04");
            e.setId(f.getId());
            ups.add(e);
        });
        this.updateBatchById(ups);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void savePwPgdXdBack(List<PgdPwjh> pwjhs, HttpServletRequest request) {
        List<PgdPwjh>ups= new ArrayList<>();
        pwjhs.forEach(f->{
            PgdPwjh e= new PgdPwjh();
            e.setJsrq("");
            e.setJsrq("");
            if(f.getZt().equals("03")){
                e.setZt("02");
            }
            e.setId(f.getId());
            ups.add(e);
        });
        this.updateBatchById(ups);
    }
}
